import contextlib

import bpy

from .load_post import load_post_handler


HANDLERS = {
    "load_post": load_post_handler,
}


def register():
    for event, handler in HANDLERS.items():
        getattr(bpy.app.handlers, event).append(handler)


def unregister():
    for event, handler in HANDLERS.items():
        with contextlib.suppress(Exception):
            getattr(bpy.app.handlers, event).remove(handler)
