import contextlib
from pathlib import Path

from bpy.utils import previews


pcoll = None


def icon_id(name):
    global pcoll
    return pcoll[name].icon_id if icon_exists(name) else None


def icon_exists(name):
    return name in pcoll if pcoll else False


def load_icon(path, name):
    global pcoll
    with contextlib.suppress(Exception):
        pcoll.load(name, str(path), "IMAGE")


def register():
    global pcoll
    pcoll = previews.new()
    dir_path = Path(__file__).parent
    for file in dir_path.glob("*.png"):
        load_icon(file, file.name)


def unregister():
    global pcoll
    previews.remove(pcoll)
    pcoll = None
