import bpy

from ..utils.ui import draw_icon
from .. import addon_id


class PopupBase(bpy.types.Operator):
    bl_idname = f"{addon_id}.popup_base"
    bl_label = ""
    bl_options = {"INTERNAL"}

    action: bpy.props.StringProperty(default="init", options={"HIDDEN", "SKIP_SAVE"})

    icon: str = None
    dialog = False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        if self.action == "init":
            wm = context.window_manager
            return (
                wm.invoke_props_dialog(self, width=300)
                if self.dialog
                else wm.invoke_popup(self)
            )

    def draw(self, context):
        if self.icon is None:
            return

        layout = self.layout
        draw_icon(layout, self.icon, spacing_top=1)
