import bpy

from .popup_base import PopupBase
from ..utils.ui import draw_paragraph, draw_send_email
from .. import addon_id


class BLENDAI_OT_ReportBug(PopupBase, bpy.types.Operator):
    bl_idname = f"{addon_id}.report_bug"

    icon = "ERROR"

    def draw(self, context):
        super().draw(context)
        layout = self.layout
        text = "You have experienced a bug?"
        draw_paragraph(layout, text, alignment="CENTER")
        text = "Please send an Email with a detailed description of the bug to report it.\nThanks for your help!"
        draw_paragraph(layout, text, alignment="CENTER")

        row = layout.row()
        row.active_default = True

        subject = "Bug Report"
        body = (
            "Replace this text with a detailed description of the bug."
            "\nPlease include error messages if any or images if possible."
            "\nThanks for your help!"
        )
        draw_send_email(
            row, subject=subject, body=body, include_addon_info=True, show_icon=False
        )
