import bpy

from .popup_base import PopupBase
from ..utils.ui import draw_paragraph, draw_send_email, draw_discord_invite
from .. import addon_id, bl_info


class BLENDAI_OT_RequestFeature(PopupBase, bpy.types.Operator):
    bl_idname = f"{addon_id}.request_feature"

    icon = "LIGHT"

    def draw(self, context):
        super().draw(context)
        layout = self.layout
        text = f"You have new ideas for {bl_info['name']}?"
        draw_paragraph(layout, text, alignment="CENTER")
        text = "That's awesome! You can share them on Discord to discuss them with the community or just send an Email.\nThanks for your input!"
        draw_paragraph(layout, text, alignment="CENTER")

        col = layout.column(align=True)
        row = col.row()
        row.active_default = True

        subject = "Feature Request"
        body = (
            "Replace this text with a description of your new ideas."
            "\nThe more detailed, the better."
            "\nThanks for your input!"
        )
        draw_discord_invite(row, text="Discuss on Discord", show_icon=False)
        draw_send_email(
            col, subject=subject, body=body, include_addon_info=True, show_icon=False
        )
