import bpy

from .categories_pg import INSTANTCLEAN_PG_Categories
from .misc_pg import INSTANTCLEAN_PG_Misc
from .repair_pg import INSTANTCLEAN_PG_RepairSettings
from .manifold_pg import INSTANTCLEAN_PG_ManifoldSettings
from .dissolve_pg import INSTANTCLEAN_PG_DissolveSettings
from .topology_pg import INSTANTCLEAN_PG_TopologySettings
from .normals_pg import INSTANTCLEAN_PG_NormalsSettings
from .objectdata_pg import INSTANTCLEAN_PG_ObjectdataSettings


PROPS = {
    "instantclean_categories": INSTANTCLEAN_PG_Categories,
    "instantclean_misc": INSTANTCLEAN_PG_Misc,
    "instantclean_repair": INSTANTCLEAN_PG_RepairSettings,
    "instantclean_manifold": INSTANTCLEAN_PG_ManifoldSettings,
    "instantclean_dissolve": INSTANTCLEAN_PG_DissolveSettings,
    "instantclean_topology": INSTANTCLEAN_PG_TopologySettings,
    "instantclean_normals": INSTANTCLEAN_PG_NormalsSettings,
    "instantclean_objectdata": INSTANTCLEAN_PG_ObjectdataSettings,
}


def register():
    for key, value in PROPS.items():
        setattr(bpy.types.Scene, key, bpy.props.PointerProperty(type=value))


def unregister():
    for key in PROPS.keys():
        delattr(bpy.types.Scene, key)
