import bpy
from bpy.types import PropertyGroup
from bpy.props import BoolProperty, FloatProperty


class INSTANTCLEAN_PG_DissolveSettings(PropertyGroup):
    max_angle: FloatProperty(
        name="最大角度",
        default=0.0875,
        subtype="ANGLE",
        description="几何图形将被融并面的最大角度",
    )

    boundaries: BoolProperty(name="保持边界", description="仅连接到一个面的边")

    protect_sharp: BoolProperty(
        name="排除-锐边", default=True, description="排除锐边"
    )

    protect_seam: BoolProperty(
        name="排除-缝合边", default=True, description="排除缝合边"
    )

    protect_uv: BoolProperty(
        name="排除-UV边界", default=True, description="从溶解中排除作为UV岛边界的边"
    )

    protect_materials: BoolProperty(
        name="排除-材质边界",
        default=True,
        description="排除将两种不同的指定材质从溶解中划界的边",
    )
