import bpy
from bpy.types import PropertyGroup
from bpy.props import BoolProperty, IntProperty, FloatProperty


class INSTANTCLEAN_PG_ManifoldSettings(PropertyGroup):
    non_manifold_faces: BoolProperty(
        name="非流形面",
        default=True,
        description="具有连接到两个以上面或位于网格内部的边的面 (例如内部面)",
    )

    non_manifold_verts: BoolProperty(
        name="非流形顶点",
        default=True,
        description="拆分连接零尺寸点的网格两部分的顶点",
    )

    wire_geo: BoolProperty(name="线框(不含面)", default=True, description="不包含任何面的几何图形")

    fill_holes: BoolProperty(
        name="填充孔洞",
        default=False,
        description="Fill up holes in the mesh",
    )

    fill_holes_max_sides: IntProperty(
        name="填充孔洞-最大边数",
        default=4,
        description="仅用最多此数量的边填充孔",
    )

    flatten: BoolProperty(
        name="平展面",
        default=False,
        description="通过移动顶点以匹配平均平面来展平不在同一平面中的面",
    )

    flatten_iterations: IntProperty(
        name="迭代次数", default=3, description="重复压平过程次数"
    )

    flatten_factor: FloatProperty(
        name="Factor",
        default=1.0,
        description="Determines how strong vertices will be moved to make all faces as flat as possible",
    )

    undistort: BoolProperty(
        name="非扭曲面",
        default=False,
        description="对非平面进行三角测量，以创建尽可能多的平面",
    )

    undistort_ang: FloatProperty(
        name="Max Angle",
        subtype="ANGLE",
        default=0.087266,
        description="仅对比此数量更扭曲的面进行三角剖分",
    )
