import bpy
from bpy.types import PropertyGroup
from bpy.props import BoolProperty, FloatProperty, EnumProperty


class INSTANTCLEAN_PG_NormalsSettings(PropertyGroup):
    recalculate: BoolProperty(name="重新计算", default=True, description="Recalculate the normal of each face")

    recalculate_orientation: EnumProperty(
        name="Orientation",
        items=[("OUTSIDE", "Outside", "", "", 0), ("INSIDE", "Inside", "", "", 1)],
        description="Recalculation orientation",
    )

    auto_smooth: BoolProperty(name="Auto Smooth", default=True, description="Smoothes normals based of the angle")

    auto_smooth_ang: FloatProperty(
        name="Max Angle",
        default=0.785398,
        subtype="ANGLE",
        description="Maximal angle between face normals that will be considered as smooth",
    )

    weighted_normals: BoolProperty(name="加权法线", default=False)

    clear_custom_split_normals: BoolProperty(
        name="自定义分割法线", default=True, description="Clears custom split normals if any available"
    )

    clear_sharp_edges: BoolProperty(
        name="Sharp Edges", default=True, description="Clears sharp edges i.a. resulting from custom split normals"
    )
