# Instant Clean  Copyright (C) 2023  Ruben Messerschmidt

# Instant Clean is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# Instant Clean is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.


import bpy
from bpy.types import PropertyGroup
from bpy.props import BoolProperty, EnumProperty


class INSTANTCLEAN_PG_ObjectdataSettings(PropertyGroup):
    material_slots: BoolProperty(
        name="材质槽",
        default=True,
        description="移除其材质未指定给网格的所有材质槽",
    )

    material_slots_clear: EnumProperty(
        name="Clear Method",
        items=[
            ("UNUSED", "仅使用的", "Clear unused material slots only", "", 0),
            ("ALL", "全部", "Clear all material slots", "", 1),
        ],
        description="Material slots clearing method",
    )

    double_materials: BoolProperty(
        name="重复的材质",
        default=True,
        description="将所有以相同名称开头的材料分别合并为一个",
    )

    double_materials_remove_data: BoolProperty(
        name="Remove Data", default=False, description="破坏性地从文件中删除重复材质（类似.001后缀）"
    )

    empty_vertex_groups: BoolProperty(
        name="空顶点组",
        default=True,
        description="Removes all vertex groups which have no vertices assigned to it",
    )
