import bpy
from bpy.types import PropertyGroup
from bpy.props import BoolProperty, FloatProperty


def update(self, context):
    bpy.ops.ed.undo_push(message="Changed Setting")


class INSTANTCLEAN_PG_RepairSettings(PropertyGroup):
    loose: BoolProperty(name="松散元素", default=True, description="未连接的几何图形", update=update)

    loose_verts: BoolProperty(name="Loose Verts", default=True, description="Vertices which are not part of an edge")

    loose_edges: BoolProperty(name="Loose Edges", default=True, description="Edges which are not part of an face")

    loose_faces: BoolProperty(
        name="Loose Faces", default=True, description="Faces which are not connected to other faces"
    )

    doubles: BoolProperty(name="重叠", default=True, description="具有相同位置的顶点", update=update)

    doubles_dst: FloatProperty(
        name="最大距离",
        default=0.0001,
        subtype="DISTANCE",
        description="这个距离内的点会被合并",
    )

    zero_faces: BoolProperty(name="0面积", default=True, description="合并面积为零的面")

    zero_faces_area: FloatProperty(
        name="最大面积",
        default=0.0001,
        subtype="DISTANCE",
        description="这个面积内的面会被合并",
    )

    dispensables: BoolProperty(
        name="排除规则", default=True, description=""
    )

    dispensables_ang: FloatProperty(
        name="最大角度",
        default=0.0875,
        subtype="ANGLE",
        description="两条边之间的最大角度小于这个值会被修复",
    )
