import bpy

from .main_panel import INSTANTCLEAN_PT_MainPanel
from .repair_panel import INSTANTCLEAN_PT_RepairPanel
from .manifold_panel import INSTANTCLEAN_PT_ManifoldPanel
from .dissolve_panel import INSTANTCLEAN_PT_DissolvePanel
from .topology_panel import INSTANTCLEAN_PT_TopologyPanel
from .normals_panel import INSTANTCLEAN_PT_NormalsPanel
from .objectdata_panel import INSTANTCLEAN_PT_ObjectdataPanel
from ..utils.cache import Preferences


PANELS = [
    # # INSTANTCLEAN_PT_MainPanel,
    # INSTANTCLEAN_PT_RepairPanel,
    # INSTANTCLEAN_PT_ManifoldPanel,
    # INSTANTCLEAN_PT_DissolvePanel,
    # INSTANTCLEAN_PT_TopologyPanel,
    # INSTANTCLEAN_PT_NormalsPanel,
    # INSTANTCLEAN_PT_ObjectdataPanel,
]


def register():
    for panel in PANELS:
        bpy.utils.register_class(panel)

def unregister():
    for panel in reversed(PANELS):
        bpy.utils.unregister_class(panel)


def update_panels():
    merge = Preferences.get("merge_panel")
    for panel in PANELS:
        panel.set_merge(merge)
