import bpy
from .panel_base import PanelBase
from .layout_temps import sub_layout, sub_panel_header, results_layout


class INSTANTCLEAN_PT_DissolvePanel(PanelBase, bpy.types.Panel):
    bl_label = ""

    @classmethod
    def poll(cls, context):
        return not context.scene.instantclean_misc.results or (
            context.scene.instantclean_categories.dissolve
            and bpy.context.scene["Dissolve"] is not None
            and [
                v
                for k, v in bpy.context.scene["Dissolve"].items()
                if type(v) != type(False)
            ]
        )

    def draw_header(self, context):
        sub_panel_header(
            self.layout, "dissolve", context.scene.instantclean_misc.results
        )

    def draw(self, context):
        layout = self.layout
        layout.enabled = context.scene.instantclean_categories.dissolve
        pg = context.scene.instantclean_dissolve

        sub = sub_layout(layout, 3)

        if not context.scene.instantclean_misc.results:
            sub.prop(pg, "max_angle")
            sub.prop(pg, "boundaries")

            sub.separator()
            sub.label(text="保护选项：")
            box = sub.box()
            split = box.split()

            col = split.column()
            col.prop(pg, "protect_seam")
            col.prop(pg, "protect_uv")

            col = split.column()
            col.prop(pg, "protect_sharp")
            col.prop(pg, "protect_materials")
        else:
            results_layout(sub, bpy.context.scene["Dissolve"])
