import bpy

from .panel_base import PanelBase
from ..ops.presets_op import INSTANTCLEAN_MT_PresetMenu
from .layout_temps import sub_layout, results_layout
from .. import addon_id, bl_info


class INSTANTCLEAN_PT_MainPanel(PanelBase, bpy.types.Panel):
    bl_label = bl_info["name"]

    def draw(self, context):
        layout = self.layout
        scene = context.scene
        pg = scene.instantclean_misc

        # addon info
        col = layout.column()
        split = layout.split()
        col = split.column()
        col.enabled = True


        sub = sub_layout(layout, 3)

        col.separator()

        row = sub.row()
        row.scale_y = 2
        if bpy.context.mode not in ("OBJECT", "EDIT_MESH"):
            row.enabled = False

        # clean button
        if pg.results:
            row.operator("instantclean.clean", text="Close Results").action = "close"
        else:
            row.operator("instantclean.clean", text="Clean").action = "all"

        row.separator(factor=1.8)

        # preset menu
        if not pg.results:
            row = sub.row(align=True)
            row.menu(
                INSTANTCLEAN_MT_PresetMenu.__name__,
                text=INSTANTCLEAN_MT_PresetMenu.bl_label,
            )
            row.operator("instantclean.override_preset", text="", icon="DUPLICATE")
            row.operator("instantclean.add_preset", text="", icon="ADD")
            row.operator(
                "instantclean.add_preset", text="", icon="REMOVE"
            ).remove_active = True
            row.separator(factor=3)

        else:
            sub.separator()
            sub.label(text="Overall")
            row = sub.row()
            results_layout(row, bpy.context.scene["Stats"])
            row.separator()
