import bpy

from .panel_base import PanelBase
from .layout_temps import sub_layout, sub_panel_header, results_layout


class INSTANTCLEAN_PT_ManifoldPanel(PanelBase, bpy.types.Panel):
    bl_label = ""

    @classmethod
    def poll(cls, context):
        return not context.scene.instantclean_misc.results or (
            context.scene.instantclean_categories.manifold
            and bpy.context.scene["Manifold"] is not None
            and [
                v
                for k, v in bpy.context.scene["Manifold"].items()
                if type(v) != type(False)
            ]
        )

    def draw_header(self, context):
        sub_panel_header(
            self.layout, "manifold", context.scene.instantclean_misc.results
        )

    def draw(self, context):
        layout = self.layout
        layout.enabled = context.scene.instantclean_categories.manifold
        pg = context.scene.instantclean_manifold

        sub = sub_layout(layout, 3)

        if not context.scene.instantclean_misc.results:
            sub.prop(pg, "fill_holes")
            row = sub.row()
            row.enabled = pg.fill_holes
            row.prop(pg, "fill_holes_max_sides")

            sub.separator()
            sub.label(text="Remove")
            box = sub.box()
            col = box.column()
            col.prop(pg, "non_manifold_faces")
            col.prop(pg, "non_manifold_verts")
            col.prop(pg, "wire_geo")

            sub.separator()
            sub.label(text="Make Planar")
            box = sub.box()
            boxsub = box.column()
            split = boxsub.split()
            col = split.column()
            col.prop(pg, "undistort")
            col.prop(pg, "flatten")
            col = split.column()
            row = col.row()
            row.enabled = pg.undistort
            row.prop(pg, "undistort_ang", text="")
            row = col.row()
            row.enabled = pg.flatten
            row.prop(pg, "flatten_factor", text="")
            row = boxsub.row()
            row.enabled = pg.flatten
            row.prop(pg, "flatten_iterations", text="展平迭代数")

        else:
            results_layout(sub, bpy.context.scene["Manifold"])
