import bpy

from .panel_base import PanelBase
from .layout_temps import sub_layout, sub_panel_header, results_layout


class INSTANTCLEAN_PT_NormalsPanel(PanelBase, bpy.types.Panel):
    bl_label = ""

    @classmethod
    def poll(cls, context):
        return not context.scene.instantclean_misc.results or (
            context.scene.instantclean_categories.normals
            and bpy.context.scene["Normals"] is not None
            and [
                v
                for k, v in bpy.context.scene["Normals"].items()
                if type(v) != type(False)
            ]
        )

    def draw_header(self, context):
        sub_panel_header(
            self.layout, "normals", context.scene.instantclean_misc.results
        )

    def draw(self, context):
        layout = self.layout
        layout.enabled = context.scene.instantclean_categories.normals
        pg = context.scene.instantclean_normals

        sub = sub_layout(layout, 3)

        if not context.scene.instantclean_misc.results:
            sub.prop(pg, "recalculate")
            col = sub.column()
            col.prop(pg, "recalculate_orientation", text="")
            col.enabled = pg.recalculate

            sub.separator()

            sub.prop(pg, "auto_smooth")
            col = sub.column()
            col.prop(pg, "auto_smooth_ang")
            col.enabled = pg.auto_smooth

            sub.separator()
            sub.prop(pg, "weighted_normals")

            sub.separator()
            sub.label(text="清理数据")
            box = sub.box()
            col = box.column()
            col.prop(pg, "clear_custom_split_normals")
            col.prop(pg, "clear_sharp_edges")

        else:
            results_layout(sub, bpy.context.scene["Normals"])
