import bpy

from .panel_base import PanelBase
from .layout_temps import sub_layout, sub_panel_header, results_layout


class INSTANTCLEAN_PT_ObjectdataPanel(PanelBase, bpy.types.Panel):
    bl_label = ""

    @classmethod
    def poll(cls, context):
        return not context.scene.instantclean_misc.results or (
            context.scene.instantclean_categories.objectdata
            and bpy.context.scene["Objectdata"] is not None
            and [
                v
                for k, v in bpy.context.scene["Objectdata"].items()
                if type(v) != type(False)
            ]
        )

    def draw_header(self, context):
        sub_panel_header(
            self.layout, "objectdata", context.scene.instantclean_misc.results
        )

    def draw(self, context):
        layout = self.layout
        layout.enabled = context.scene.instantclean_categories.objectdata
        pg = context.scene.instantclean_objectdata

        sub = sub_layout(layout, 3)

        if not context.scene.instantclean_misc.results:
            sub.label(text="材质：")
            box = sub.box()
            split = box.split()
            col = split.column()
            col.prop(pg, "double_materials")
            col.prop(pg, "material_slots")
            col = split.column()
            col.prop(
                pg, "double_materials_remove_data", text="", icon="TRASH", toggle=True
            )
            col.prop(pg, "material_slots_clear", text="")

            sub.separator()
            sub.label(text="顶点组")
            box = sub.box()
            col = box.column()
            col.prop(pg, "empty_vertex_groups")

        else:
            results_layout(sub, bpy.context.scene["Objectdata"])
