import bpy

from .panel_base import PanelBase
from .layout_temps import sub_layout, sub_panel_header, results_layout


class INSTANTCLEAN_PT_RepairPanel(PanelBase, bpy.types.Panel):
    bl_label = ""

    @classmethod
    def poll(cls, context):
        return not context.scene.instantclean_misc.results or (
            context.scene.instantclean_categories.repair
            and bpy.context.scene["Repair"] is not None
            and [
                v
                for k, v in bpy.context.scene["Repair"].items()
                if type(v) != type(False)
            ]
        )

    def draw_header(self, context):
        sub_panel_header(self.layout, "repair", context.scene.instantclean_misc.results)

    def draw(self, context):
        layout = self.layout
        layout.enabled = context.scene.instantclean_categories.repair
        pg = context.scene.instantclean_repair

        sub = sub_layout(layout, 3)

        if not context.scene.instantclean_misc.results:
            sub.label(text="移除：")
            box = sub.box()
            col = box.column()
            split = col.split()

            col = split.column()
            col.prop(pg, "loose")
            col.prop(pg, "doubles")
            col.prop(pg, "zero_faces")
            col.prop(pg, "dispensables")

            col = split.column()
            row = col.row(align=True)
            row.prop(pg, "loose_verts", icon="VERTEXSEL", icon_only=True)
            row.prop(pg, "loose_edges", icon="EDGESEL", icon_only=True)
            row.prop(pg, "loose_faces", icon="FACESEL", icon_only=True)
            row.enabled = pg.loose
            row = col.row()
            row.prop(pg, "doubles_dst", icon_only=True)
            row.enabled = pg.doubles

            row = col.row()
            row.prop(pg, "zero_faces_area", icon_only=True)
            row.enabled = pg.zero_faces
            row = col.row()
            row.prop(pg, "dispensables_ang", icon_only=True)
            row.enabled = pg.dispensables

        else:
            results_layout(sub, bpy.context.scene["Repair"])
