import bpy
from .panel_base import PanelBase
from .layout_temps import sub_layout, sub_panel_header, results_layout


class INSTANTCLEAN_PT_TopologyPanel(PanelBase, bpy.types.Panel):
    bl_label = ""

    @classmethod
    def poll(cls, context):
        return not context.scene.instantclean_misc.results or (
            context.scene.instantclean_categories.topology
            and bpy.context.scene["Topology"] is not None
            and [
                v
                for k, v in bpy.context.scene["Topology"].items()
                if type(v) != type(False)
            ]
        )

    def draw_header(self, context):
        sub_panel_header(
            self.layout, "topology", context.scene.instantclean_misc.results
        )

    def draw(self, context):
        layout = self.layout
        layout.enabled = context.scene.instantclean_categories.topology
        pg = context.scene.instantclean_topology

        sub = sub_layout(layout, 3)

        if not context.scene.instantclean_misc.results:
            sub.label(text="转换到：")

            col = sub.column()
            col.prop(pg, "type", text="")

            if pg.type == "TRIS":
                sub.separator()
                sub.label(text="方法：")
                box = sub.box()

                split = box.split(factor=0.3)

                col = split.column()
                col.label(text="Quads")
                col.label(text="NGons")

                col = split.column()
                col.prop(pg, "quad_method", text="")
                col.prop(pg, "ngon_method", text="")
            else:
                sub.prop(pg, "quad_max_face_ang")
                sub.prop(pg, "quad_max_shape_ang")
                sub.separator()
                sub.label(text="比较：")
                box = sub.box()

                split = box.split()

                col = split.column()
                col.prop(pg, "compare_sharp")
                col.prop(pg, "compare_uv")
                col.prop(pg, "compare_vcol")

                col = split.column()
                col.prop(pg, "compare_seam")
                col.prop(pg, "compare_material")
        else:
            results_layout(sub, bpy.context.scene["Topology"])
