from pathlib import Path
from .. import addon_id
import bpy


def get_path():
    return Path(__file__).resolve().parent.parent


def get_prefs():
    return bpy.context.preferences.addons[addon_id].preferences


def get_prefs_window_area():
    context = bpy.context
    window = None
    area = None
    for win in context.window_manager.windows:
        for a in win.screen.areas:
            if a.type == "PREFERENCES":
                area = a
                window = win
                break

        if window:
            break

    return None if not window and not area else (window, area)
