import bpy
import os
import shutil

from pathlib import Path
from .. import bl_info


def install_presets(replace=False):
    filepath = Path(__file__).parent.parent
    presets_path = os.path.join(
        bpy.utils.user_resource("SCRIPTS", path="presets", create=True), bl_info["name"]
    )
    if not os.path.isdir(presets_path):
        os.mkdir(presets_path)

    preset_folder = filepath.joinpath("presets")
    files = os.listdir(preset_folder)
    installed = os.listdir(presets_path)
    if replace:
        for f in files:
            if f in installed:
                os.remove(os.path.join(presets_path, f))
            shutil.copy2(os.path.join(preset_folder, f), presets_path)

    else:
        for f in [f for f in files if f not in installed]:
            shutil.copy2(os.path.join(preset_folder, f), presets_path)
