import requests

from .. import bl_info


def get_this_version_name():
    return bl_info["version"]


def get_latest_version_name(include_prerelease=False):
    try:
        data = requests.get(
            bl_info["version_url"],
        )

    except Exception:
        return

    if data.status_code == 200:
        latest_version = tuple(int(n) for n in (data.text.split(".")))
        if latest_version > bl_info["version"]:
            return latest_version
